#include "dcastaway.h"
#include "config.h"
#include "st.h"
#include "vkbd/vkbd.h"

SDL_Surface *screen=NULL;
static unsigned int screen_buffer, screen_pitch, screen_add=20;

static unsigned long vm2bm1[256];
static unsigned long vm2bm2[256];

static unsigned short pal16[16]={ 0, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768 };

unsigned short render_pal16_copy0=0;

void render_blank_screen(void)
{
    	SDL_FillRect(screen,NULL,render_pal16_copy0);
	SDL_Flip(screen);
}

void render_force_background(void)
{
	register unsigned p0=pal16[0];
#ifdef DREAMCAST
	register unsigned r=(unsigned)( 8.2259 * (double)((p0>>11)&0x1f));
	register unsigned g=(unsigned)( 4.0477 * (double)((p0>>5)&0x3f));
	register unsigned b=(unsigned)( 8.2259 * (double)(p0&0x1f));
	vid_border_color(r,g,b);
#endif
	render_pal16_copy0=p0;
}

void render_up_screen(void)
{
#ifndef DREAMCAST
	SDL_Rect r;
	r.x=0;
	r.y=200;
	r.w=320;
	r.h=40;
	SDL_FillRect(screen,&r,render_pal16_copy0);
#else
	{
		register int i;
		register short col=render_pal16_copy0;
		for(i=200;i<240;i++)
		{
			register short *p=(short *)((unsigned)(screen->pixels)+i*screen->pitch);
			register int j;
			for(j=0;j<(320/4);j++)
			{
				*p++=col;
				*p++=col;
				*p++=col;
				*p++=col;
			}
		}
	}
#endif
#ifndef USE_DOUBLE_BUFFER
	SDL_UpdateRect(screen, 0 , 200, 320, 40);
#else
//	SDL_Flip(screen);
#endif
	screen_add=0;
}

void render_down_screen(void)
{
#ifndef DREAMCAST
	SDL_Rect r;
	r.x=0;
	r.y=0;
	r.w=320;
	r.h=20;
	SDL_FillRect(screen,&r,render_pal16_copy0);
#else
	{
		register int i;
		register short col=render_pal16_copy0;
		for(i=0;i<20;i++)
		{
			register short *p=(short *)((unsigned)(screen->pixels)+i*screen->pitch);
			register int j;
			for(j=0;j<(320/4);j++)
			{
				*p++=col;
				*p++=col;
				*p++=col;
				*p++=col;
			}
		}
	}
#endif
#ifndef USE_DOUBLE_BUFFER
	SDL_UpdateRect(screen, 0 , 0, 320, 20);
#endif
#ifndef DREAMCAST
	r.x=0;
	r.y=220;
	r.w=320;
	r.h=20;
	SDL_FillRect(screen,&r,render_pal16_copy0);
#else
	{
		register int i;
		register short col=render_pal16_copy0;
		for(i=220;i<240;i++)
		{
			register short *p=(short *)((unsigned)(screen->pixels)+i*screen->pitch);
			register int j;
			for(j=0;j<(320/4);j++)
			{
				*p++=col;
				*p++=col;
				*p++=col;
				*p++=col;
			}
		}
	}
#endif
#ifndef USE_DOUBLE_BUFFER
	SDL_UpdateRect(screen, 0 , 220, 320, 20);
#else
//	SDL_Flip(screen);
#endif
	screen_add=20;
}

#ifndef DREAMCAST
void video_fullscreen(void)
{
	static int full=0;
	Uint32 flags=SDL_HWSURFACE | SDL_HWPALETTE;
	void *buff=calloc(320,240*2);
	SDL_LockSurface(screen);
	memcpy(buff,screen->pixels,320*240);
	SDL_UnlockSurface(screen);
#ifdef USE_DOUBLE_BUFFER
	flags|=SDL_DOUBLEBUF;
#endif
	if (!(full&1))
		flags|=SDL_FULLSCREEN;
	screen=SDL_SetVideoMode(320, 240, 16, flags);
	screen_buffer=(unsigned int)screen->pixels;
	screen_pitch=screen->pitch;
	SDL_LockSurface(screen);
	memcpy(screen->pixels,buff,320*240);
	SDL_UnlockSurface(screen);
	free(buff);
	full++;
	render_no_border();
	render_vkbd_background();
	Draw_border(0);
}
#endif

void render_init(void)
{
	int i;
	if (screen==NULL)
	{
 	   screen = SDL_SetVideoMode(320, 240, 16, SDL_HWSURFACE | SDL_HWPALETTE | SDL_FULLSCREEN);
 	   SDL_ShowCursor(SDL_DISABLE);
 	   if (screen == NULL) {
 	       fprintf(stderr, "SDL_SetVideoMode(): %s\n", SDL_GetError());
 	       exit(1);
 	   }
    	   SDL_FillRect(screen,NULL,0);
	}
	screen_buffer=(unsigned int)screen->pixels;
	screen_add=20;
	screen_pitch=screen->pitch;
	for (i = 0; i < 256; i++) {
		vm2bm1[i] =
			((i & 0x10) ? 0x01000000L : 0)
			| ((i & 0x20) ? 0x00010000L : 0)
			| ((i & 0x40) ? 0x00000100L : 0)
			| ((i & 0x80) ? 0x00000001L : 0);
		vm2bm2[i] =
			((i & 0x01) ? 0x01000000L : 0)
			| ((i & 0x02) ? 0x00010000L : 0)
			| ((i & 0x04) ? 0x00000100L : 0)
			| ((i & 0x08) ? 0x00000001L : 0);
	}
}

void Draw_border(int e)
{
	if (screen_add)
	{
		register unsigned p0=pal16[0];
		if (render_pal16_copy0!=p0)
		{
			render_force_background();
			if (!e)
				render_down_screen();
		}
	}
}

void render_vkbd_background(void)
{
	if (!screen_add)
	{
		register unsigned p0=pal16[0];
		if (render_pal16_copy0!=p0)
		{
			render_force_background();
			render_up_screen();
			vkbd_redraw();
		}
	}
}

void render_no_border(void)
{
	render_pal16_copy0=~pal16[0];
#ifdef DREAMCAST
	vid_border_color(0,0,0);
#endif
}


void Redraw ( int row, int vid_adr ) {

	if (vid_flag) {
		vid_flag = 0;
		register unsigned i;
		for (i = 0; i < 16; i++) {
#ifndef DREAMCAST
            		unsigned b = (unsigned)(36.428 * (double)((vid_col[i] & 0x7)));
            		unsigned g = (unsigned)(36.428 * (double)(((vid_col[i] >> 4) & 0x7)));
            		unsigned r = (unsigned)(36.428 * (double)(((vid_col[i] >> 8) & 0x7)));
	   		pal16[i]=(unsigned short)SDL_MapRGB(screen->format,r,g,b);
#else
            		register unsigned b = (unsigned)(4.4286 * (double)((vid_col[i] & 0x7)));
            		register unsigned g = 9 * (unsigned)(((vid_col[i] >> 4) & 0x7));
            		register unsigned r = (unsigned)(4.4286 * (double)(((vid_col[i] >> 8) & 0x7)));
			pal16[i]= (r<<11)|(g<<5)|(b);
#endif
		}
	}
	{
		register int real_row=(row+screen_add);
		if (real_row<0 || real_row>=240)
			return;
	}
	register unsigned long *line_o =
		(unsigned long *) (screen_buffer +  screen_pitch * (row+screen_add));
#ifndef DREAMCAST
	if (SDL_MUSTLOCK(screen))
        	if (SDL_LockSurface(screen)<0)
			return;
#ifndef USE_DOUBLE_BUFFER
	if ((screen_buffer!=(unsigned int)screen->pixels)||(screen_pitch!=screen->pitch))
	{
		screen_buffer=(unsigned int)screen->pixels;
		screen_pitch=screen->pitch;
		line_o=(unsigned long *) (screen_buffer +  screen_pitch * (row+screen_add));
	}
#endif
#else
	{
	  unsigned long *cpy_o=(unsigned long *)(0xe0000000 | ((unsigned)line_o) & 0x03ffffe0);
	  QACR0 = ((((unsigned int)line_o)>>26)<<2)&0x1c;
	  QACR1 = ((((unsigned int)line_o)>>26)<<2)&0x1c;
	  line_o=cpy_o;
	}
#endif
	{
	register int col;
	register unsigned char *line_i =
		(unsigned char *)(((unsigned char *)membase)+vid_adr);
	for (col = 0; col < 20; col ++) {
		register unsigned long val;
		unsigned char val7 = *line_i++;
		unsigned char val6 = *line_i++;
		unsigned char val5 = *line_i++;
		unsigned char val4 = *line_i++;
		unsigned char val3 = *line_i++;
		unsigned char val2 = *line_i++;
		unsigned char val1 = *line_i++;
		unsigned char val0 = *line_i++;
#ifdef DREAMCAST
		asm("pref @%0" : : "r" (line_i));
#endif

		val =     (vm2bm1[val6])
			+ (vm2bm1[val4] << 1)
			+ (vm2bm1[val2] << 2)
			+ (vm2bm1[val0] << 3);
		line_o[0] = pal16[val&0x0f] |
			(((unsigned long)pal16[(val>>8)&0x0f])<<16);
		line_o[1] = pal16[(val>>16)&0x0f] |
			(((unsigned long)pal16[(val>>24)&0x0f])<<16);

		val =     (vm2bm2[val6])
			+ (vm2bm2[val4] << 1)
			+ (vm2bm2[val2] << 2)
			+ (vm2bm2[val0] << 3);
		line_o[2] = pal16[val&0x0f] |
			(((unsigned long)pal16[(val>>8)&0x0f])<<16);
		line_o[3] = pal16[(val>>16)&0x0f] |
			(((unsigned long)pal16[(val>>24)&0x0f])<<16);

		val =     (vm2bm1[val7])
			+ (vm2bm1[val5] << 1)
			+ (vm2bm1[val3] << 2)
			+ (vm2bm1[val1] << 3);
		line_o[4] = pal16[val&0x0f] |
			(((unsigned long)pal16[(val>>8)&0x0f])<<16);
		line_o[5] = pal16[(val>>16)&0x0f] |
			(((unsigned long)pal16[(val>>24)&0x0f])<<16);

		val =     (vm2bm2[val7])
			+ (vm2bm2[val5] << 1)
			+ (vm2bm2[val3] << 2)
			+ (vm2bm2[val1] << 3);
		line_o[6] = pal16[val&0x0f] |
			(((unsigned long)pal16[(val>>8)&0x0f])<<16);
		line_o[7] = pal16[(val>>16)&0x0f] |
		 	(((unsigned long)pal16[(val>>24)&0x0f])<<16);
#ifdef DREAMCAST
		asm("pref @%0" : : "r" (line_o));
#endif
		line_o+=8;
	}
	}
#ifndef DREAMCAST
	if (SDL_MUSTLOCK(screen))
        	SDL_UnlockSurface(screen);
#else
	line_o=(unsigned long *)0xe0000000;
	line_o[0] = line_o[8] = 0;
#endif
#ifndef USE_DOUBLE_BUFFER
	SDL_UpdateRect(screen, 0, row+screen_add, 320, 1);
#endif
}

void Redraw_med ( int row, int vid_adr ) {

	if (vid_flag) {
		unsigned char i,r, g, b;
		vid_flag = 0;
		for (i = 0; i < 4; i++) {
#ifndef DREAMCAST
            		unsigned b = (unsigned)(36.428 * (double)((vid_col[i] & 0x7)));
            		unsigned g = (unsigned)(36.428 * (double)(((vid_col[i] >> 4) & 0x7)));
            		unsigned r = (unsigned)(36.428 * (double)(((vid_col[i] >> 8) & 0x7)));
	   		pal16[i]=(unsigned short)SDL_MapRGB(screen->format,r,g,b);
#else
            		register unsigned b = (unsigned)(4.4286 * (double)((vid_col[i] & 0x7)));
            		register unsigned g = 9 * (unsigned)(((vid_col[i] >> 4) & 0x7));
            		register unsigned r = (unsigned)(4.4286 * (double)(((vid_col[i] >> 8) & 0x7)));
			pal16[i]= (r<<11)|(g<<5)|(b);
#endif
		}
	}
	{
		register int real_row=(row+screen_add);
		if (real_row<0 || real_row>=240)
			return;
	}
	register unsigned long *line_o =
		(unsigned long *) (screen_buffer + screen_pitch * (row+screen_add));
#ifndef DREAMCAST
	if (SDL_MUSTLOCK(screen))
        	if (SDL_LockSurface(screen)<0)
			return;
#ifndef USE_DOUBLE_BUFFER
	if ((screen_buffer!=(unsigned int)screen->pixels)||(screen_pitch!=screen->pitch))
	{
		screen_buffer=(unsigned int)screen->pixels;
		line_o=(unsigned long *) (screen_buffer +  screen_pitch * (row+screen_add));
	}
#endif
#else
	{
	  unsigned long *cpy_o=(unsigned long *)(0xe0000000 | ((unsigned)line_o) & 0x03ffffe0);
	  QACR0 = ((((unsigned int)line_o)>>26)<<2)&0x1c;
	  QACR1 = ((((unsigned int)line_o)>>26)<<2)&0x1c;
	  line_o=cpy_o;
	}
#endif
	{
	register unsigned int *line_i =
		(unsigned int *)(((unsigned char *)membase)+vid_adr);
	register int col;
	for ( col=0; col<20; col++)
	{
		register unsigned int r0,r1;
		r0 = *line_i++;
		r1=r0&0x55555555;
		r0=(r0>>1)&0x55555555;
		r0+=(r0>>15);
		r1+=(r1>>15);
		line_o[0] = pal16[((r1>>12)&12)+((r0>>14)&3)] |
			(((unsigned long)pal16[((r1>>10)&12)+((r0>>12)&3)])<<16);
		line_o[1] = pal16[((r1>>8)&12)+((r0>>10)&3)] |
			(((unsigned long)pal16[((r1>>6)&12)+((r0>>8)&3)])<<16);
		line_o[2] = pal16[((r1>>4)&12)+((r0>>6)&3)] |
			(((unsigned long)pal16[((r1>>2)&12)+((r0>>4)&3)])<<16);
		line_o[3] = pal16[(r1&12)+((r0>>2)&3)] |
			(((unsigned long)pal16[((r1<<2)&12)+(r0&3)])<<16);
		r0 = *line_i++;
		r1=r0&0x55555555;
		r0=(r0>>1)&0x55555555;
		r0+=(r0>>15);
		r1+=(r1>>15);
		line_o[4] = pal16[((r1>>12)&12)+((r0>>14)&3)] |
			(((unsigned long)pal16[((r1>>10)&12)+((r0>>12)&3)])<<16);
		line_o[5] = pal16[((r1>>8)&12)+((r0>>10)&3)] |
			(((unsigned long)pal16[((r1>>6)&12)+((r0>>8)&3)])<<16);
		line_o[6] = pal16[((r1>>4)&12)+((r0>>6)&3)] |
			(((unsigned long)pal16[((r1>>2)&12)+((r0>>4)&3)])<<16);
		line_o[7] = pal16[(r1&12)+((r0>>2)&3)] |
			(((unsigned long)pal16[((r1<<2)&12)+(r0&3)])<<16);
#ifdef DREAMCAST
		asm("pref @%0" : : "r" (line_o));
#endif
		line_o+=8;
	}
	}
#ifndef DREAMCAST
	if (SDL_MUSTLOCK(screen))
        	SDL_UnlockSurface(screen);
#else
	line_o=(unsigned long *)0xe0000000;
	line_o[0] = line_o[8] = 0;
#endif
#ifndef USE_DOUBLE_BUFFER
	SDL_UpdateRect(screen, 0, row + screen_add, 320, 1);
#endif
}

void render_status ( void ) {
	SDL_Flip(screen);
}
